#ifndef OUTPUTT_H
#define OUTPUTT_H
#include <stdio.h>
#include "descrip.h"

/// main output function
long outputt(FILE *out, descrip *d);

/// output nodes
long wr_nodest(FILE *out);

/// output boundary conditions
long wr_bocont(FILE *out);

/// output elements
long wr_elementst(FILE *out, descrip *d);

/// output global node numbers for paralell computing
long wr_globnodnumt(FILE *out);

/// output materials
long wr_materialst(FILE *out);

/// output cross-sections
long wr_crsecst(FILE *out);

/// load controling function
long wr_loadcaset(FILE *out);

/// output of prescribed quantities
long wr_prescquant(FILE *out);

/// output of sources at nodes and elements
long wr_sources(FILE *out, long nlc);

/// output element load
long wr_loadelt(FILE *out, long nlc);

/// output initial conditions
long wr_initcondt(FILE *out);

#endif
