#ifndef ELEMSWITCHT_H
#define ELEMSWITCHT_H

#include "aliast.h"
#include "matrix.h"

void conductmat (long eid,long lcid,matrix &km);
void capacmat (long eid,long lcid,matrix &cm);

void intpointvalues (long eid);
void intpointvalues_puc (long eid);
void intpointgradients (long eid);
void intpointfluxes (long eid);
void intpointothers (long eid);
void intpointeqothers (long eid);

void source_vector (long lcid,long eid,vector &nodval,vector &lv);

void compute_ipfluxes ();
void compute_ipotherst ();
void compute_ipeqotherst ();

void compute_nodegrads ();
void compute_nodefluxes ();
void compute_nodeotherst ();
void compute_nodeotherst_comp ();
void compute_nodeeqotherst ();

void internal_fluxes (double *intflux,long n);

void elem_neumann_vector (vector &lv,long lcid,long eid,long i);
void elem_newton_vector (vector &lv,long lcid,long eid,long i);
void elem_transmission_flux (vector &lv,long lcid,long eid,long i);
void volume_rhs_vector (vector &lv,long lcid,long eid);
void lmat (long eid,long lcid,matrix &lm);
void ltmat (long eid,long lcid,matrix &lm);
void averdmat (long eid,double &elemarea,matrix &km);
void avercmat (long eid,double &elemarea,matrix &cm);

#endif
