#ifndef GLOBMATT_H
#define GLOBMATT_H

#include "genfile.h"
#include "aliast.h"

void conductivity_matrix (long lcid);

void capacity_matrix (long lcid);

void residuum (double *r,double *p,double *v,double dt,long n,long lcid);

void elemvalues_puc (long lcid,long eid,double *r,long ndofe);
void elemvalues (long lcid,long eid,double *r,long *cn,long ndofe);
void nodval (long lcid,double *r, long idn);
void initnodval (long lcid,double *r, long idn);
void prevnodval (long lcid,double *r, long idn,double *lhs);
void nodalotherval (double *r,ivector &nod);
void nodalderivatives (double *r,long *cn,long ndofe);
void prescvalues (double *r,long *cn,long ndofe);
void initialvalues (double *r,long *cn,long ndofe);


void approximation ();
void approximation_puc ();
void actual_previous_change ();
void actual_previous_nodval ();

void assemble_init (double *rhs);
void trfel_right_hand_side (long lcid,double *rhs,long n);
void trfel_bound_flux (long lcid,double *rhs,long n);

void compute_req_valt (long lcid);


void give_nodal_humid (double *gv,long mnt);

void solution_correction ();

void compute_cycles (double *plhs,double *pplhs);

void copy_nodval (long lcid);

void assemble_gradients_contrib(double *rhs);
void assemble_l_matrix (matrix &lm, matrix &ltm);
void assemble_conductivity_matrix (matrix &km);
void assemble_average_d_matrix (matrix &km, double &area);
void assemble_average_c_matrix (matrix &cm);

#endif
