#ifndef NPSOLVERT_H
#define NPSOLVERT_H

#include <stdio.h>
#include "timecontr.h"

void solve_nonstationary_problem ();

void linear_nonstat_solv_vform ();
void linear_nonstat_solv_dform ();

void aux_nonlintime_print (FILE *aux, double *r, double l);
void npsolvert_save (double *r, double *dr, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void npsolvert_save_text (double *r, double *dr, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void npsolvert_save_binary (double *r, double *dr, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void npsolvert_save_text_single (double *r, double *dr, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void npsolvert_save_text_multiple (double *r, double *dr, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void npsolvert_save_binary_single (double *r, double *dr, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void npsolvert_save_binary_multiple (double *r, double *dr, double *fp, long ni, double time, double dt, timecontr &tc, long n);
void npsolvert_restore (double *r, double *dr, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void npsolvert_restore_text (double *r, double *dr, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void npsolvert_restore_binary (double *r, double *dr, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void npsolvert_restore_text_single (double *r, double *dr, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void npsolvert_restore_text_multiple (double *r, double *dr, double *fp, long &ni, double &time, double &dt, timecontr &tc, long &n);
void npsolvert_restore_binary_single (double *r,double *dr, double *fp,long &ni,double &time, double &dt, timecontr &tc, long &n);
void npsolvert_restore_binary_multiple (double *r,double *dr, double *fp,long &ni,double &time, double &dt, timecontr &tc, long &n);

#endif
