#ifndef SALTMAT1_H
#define SALTMAT1_H

#include <stdio.h>
#include "genfile.h"

class saltmat1
{
 public:
  saltmat1 (void);    //constructor
  ~saltmat1 (void);   //destructor
  void read (XFILE *in);

  void matcond (matrix &d,long ri,long ci,long ipp);
  void matcap (double &c,long ri,long ci,long ipp);
  
  void matcond1d (matrix &d,long ri,long ci,long ipp);
  void matcond2d (matrix &d,long ri,long ci,long ipp);
  void matcond3d (matrix &d,long ri,long ci,long ipp);

  void auxiliarydata (double x1,double x2,double x3);
  //double saltmat1::binding_isotherms_langmuir (double x1,double x2,double x3);
 // double saltmat1::linear_data(int kod, double x1,double x2, double x3);

  double k11 (double x1,double x2,double x3);
  double k12 (double x1,double x2,double x3);
  double k13 (double x1,double x2,double x3);

  double k21 (double x1,double x2,double x3);
  double k22 (double x1,double x2,double x3);
  double k23 (double x1,double x2,double x3);

  double k31 (double x1,double x2,double x3);
  double k32 (double x1,double x2,double x3);
  double k33 (double x1,double x2,double x3);

  double c11 (double x1,double x2,double x3);
  double c12 (double x1,double x2,double x3);
  double c13 (double x1,double x2,double x3);

  double c21 (double x1,double x2,double x3);
  double c22 (double x1,double x2,double x3);
  double c23 (double x1,double x2,double x3);

  double c31 (double x1,double x2,double x3);
  double c32 (double x1,double x2,double x3);
  double c33 (double x1,double x2,double x3);

  void get_fw_vec_nodval(double &new_nodval,double &bv,double x1,double x2,double x3,long bc,long ipp);
  void get_fw_matrix(double &fv3,double x1,double x2,double x3,long bc,long ipp);
  void get_fw_flux(double &new_nodval,double &bv,double x1,double x2,double x3,long bc,long ipp);

  void get_fcf_vec_nodval(double &new_nodval,double &bv,double x1,double x2,double x3,long bc,long ipp);
  void get_fcf_matrix(double &fv3,double x1,double x2,double x3,long bc,long ipp);
  void get_fcf_flux(double &new_nodval,double &bv,double x1,double x2,double x3,long bc,long ipp);

  double get_othervalue(long compother,long ipp, double x1,double x2,double x3);
  void print_othervalue_name(FILE *out,long compother);
     void binding_izoterm_derivation(double x2, double deribi);

 private:
        int kd;
        double a1,a2,a3;
        int MatChar [20];		// popisuje pro jednotlivy material typ modelu a typ jednotlivych vlastnosti
        double MatConst [20];     // constanti hodnoty mat. vlastnosti
        double MatData [20][3][150]; // maximalni pocet 150 radku na jednu charakteristiku
        double MatFunce [20][5];   // charakterisitka zadana nejakou funkci - 5 promennych
        void CorD(int cislochar, int &kvyhl,double in, double x, double & y, double & z, double & z2);
       
};

#endif

