#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#define EXTERN
#include "globalt.h"

#include "stochdrivert.h"
#include "trfelinit.h"
#include "solvert.h"

int main (int argc, const char *argv[])
{
  time_t bt,et;
  long hod,min;
  double sec = clock();
  stochdrivert stochd;

  Stt  = NULL;
  Kmat = NULL;
  Cmat = NULL;
  Jmat = NULL;
  Bmat = NULL;
  Lbt  = NULL;
  Lbat = NULL;
  Qbt   = NULL;
  Qbat  = NULL;
  Ltt   = NULL;
  Ltat  = NULL;
  Lqt   = NULL;
  Qqt   = NULL;
  Qqat  = NULL;
  Lqat  = NULL;
  Ltett = NULL;
  Lht   = NULL;
  Qht   = NULL;

  setvbuf(stdout, NULL, _IONBF, 0);
  setvbuf(stderr, NULL, _IONBF, 0);

  bt = time (NULL);

  //  program initiation and data reading
  trfel_init (argc,argv,&stochd);
  
  
  //  solution of the problem
  //  the most important function in the code
  solve_trfel_problem (&stochd);


  et = time (NULL);
  fprintf (Outt,"\n\n\n Udaje o dobach vypoctu \n");
  fprintf (Outt,"\n\n celkova doba vypoctu             %ld",et-bt);

  sec = (clock() - sec) / (double)CLOCKS_PER_SEC;
  hod = (long)sec/3600;  sec -= hod*3600;
  min = (long)sec/60;    sec -= min*60;
  fprintf (stdout,"\n ----------------------------------");
  fprintf (stdout,"\n Consumed time by TRFEL %2ld:%02ld:%05.2f",hod,min,sec);
  fprintf (stdout,"\n ----------------------------------\n");

  //fprintf (stdout,"\n Acm = %ld \t Acv = %ld \t Aciv = %ld \n",give_acm(),give_acv(),give_aciv());
  /*
  delete Tp;
  delete Gtt;
  delete Tt;
  delete Tm;
  delete Tc;
  delete Tb;
  delete Lsrst;
  delete Stt;
  delete Outdt;
  delete Kmat;
  delete Cmat;
  delete Jmat;
  delete Bmat;
  delete Lbt;
  delete Lbat;
  delete Qbt;
  delete Qbat;
  delete Ltt;
  delete Ltat;
  delete Lqt;
  delete Qqt;
  delete Qqat;
  delete Lqat;
  delete Ltett;
  delete Lht;
  delete Qht;
  */
 // fprintf (stdout,"\n\n");  fprintf (stderr,"\n\n");  fprintf (Outt,"\n");
  fclose (Outt);
  //fclose (Outt1);
  //fclose (Outt2);

}
